/*
  -: Copyright  1999-2003 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
-------------------------------------------------------------------------------------
 Programma sortirovki massiva metodom QuickSort.

   Po-umolchaniu programma poluchaet dannie iz "input.txt": chislo, yavlaushiesya 
razmerom massiva, dalee sleduet soderjaniye massiva. Resultat vivodit v "output.txt". 
Kluchem -l programma nachnet rabotat' v rejime polnogo razbora(s klaviaturi poluchaet 
imena vhodnogo i vihodnogo fila, po okonchanii raboti vivodit ih na ekran). Cherez 
komandnuu stroku ona mojet poluchat' imena vhodnogo i vihodnogo fila.
-------------------------------------------------------------------------------------

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define STR_FILE_IN_NAME "input.txt"
#define STR_FILE_OUT_NAME "output.txt"
int MkOutFile(FILE *f_in, FILE *f_out);
void Swap(double &ldA, double &ldB);
void QuickSort(unsigned long int iLeft, unsigned long int iRight);
bool bAll=false;
double *dArray;

int main(int argc, char* argv[])
{
	char sFInName[256]=STR_FILE_IN_NAME, sFOutName[256]=STR_FILE_OUT_NAME, *pNothingDo;
	FILE *f_in, *f_out;
	char cRead;
	if(argc>1){
		if((argv[1][0]=='-')&&(argv[1][1]=='l')&&(argv[1][2]=='\0')){
			bAll=true;
		} else {
			pNothingDo=strcpy(sFInName,argv[1]);
			if(argc>2) pNothingDo=strcpy(sFOutName,argv[2]);
		}
	}
	//----------------begin all---
	if(bAll){
		printf("Input name of Input File:");
		scanf("%s",sFInName);
		printf("Input name of Output File:");
		scanf("%s",sFOutName);
	}
	//----------------end all-----
	f_in=fopen(sFInName,"r");
	f_out=fopen(sFOutName,"w");
	if (!f_in){
		printf("Error: can't open file with name %s\n", sFInName);
		if(bAll) scanf("%c", &cRead);
		return -1;
	}
	if (!f_out){
		printf("Error: can't open file with name %s\n", sFOutName);
		if(bAll) scanf("%c", &cRead);
		return -1;
	}
	if(MkOutFile(f_in, f_out)>=0){
		printf("Program was finished successfully!\n");
	} else {
		printf("Program was finished unsuccessfully!\n");
	}
	fclose(f_in);
	fclose(f_out);
	//----------------begin all---
	if(bAll){
		double dRead;
		f_in=fopen(sFInName,"r");
		f_out=fopen(sFOutName,"r");
		printf("Input File:\n");
		while(fscanf(f_in, "%lg", &dRead)==1){
			printf("%lg ",dRead);
		}
		printf("\n");
		printf("Output File:\n");
		while(fscanf(f_out, "%lg", &dRead)==1){
			printf("%lg ",dRead);
		}
		printf("\n");
		fclose(f_in);
		fclose(f_out);
	}
	if(bAll) scanf("%c", &cRead);
	//----------------end all-----
	return 0;
}

int MkOutFile(FILE *f_in, FILE *f_out)
{
	unsigned long int iSize;
	if(fscanf(f_in, "%ld", &iSize)!=1) return -1;
	if(iSize<=0) return -1;
	dArray = new double[iSize];
	unsigned long int i=0;
	while (i<iSize) {
		if(fscanf(f_in, "%lg", &dArray[i])!=1) return -1;
		i++;
	}
	QuickSort(0L,iSize-1);
	i=0;
	while (i<iSize) {
		fprintf(f_out,"%lg ",dArray[i]);
		i++;
	}
	delete [] dArray;
	return 1;
}
void Swap(double &ldA, double &ldB)
{
	double dC;
	dC=ldA;
	ldA=ldB;
	ldB=dC;
}
void QuickSort(unsigned long int iLeft, unsigned long int iRight)
{
	unsigned long int iY, iJ;
	double dX;
	iY=iLeft-1;
	iJ=iRight+1;
	dX=dArray[iLeft];
	do {
		do {
			iJ--;
		} while(dArray[iJ]>dX);
		do {
			iY++;
		} while(dArray[iY]<dX);
		if (iY<iJ) {
			Swap(dArray[iY],dArray[iJ]);
		}
	} while(iY<iJ);
	if (iJ+1<iRight) QuickSort(iJ+1, iRight);
	if (iLeft<iJ) QuickSort(iLeft, iJ);
}

/*
  -: Copyright  1999-2003 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
*/